/*
 * Copyright (c) 2007-2008,2010,2012,2014 Apple Inc. All Rights Reserved.
 *
 * @APPLE_LICENSE_HEADER_START@
 * 
 * This file contains Original Code and/or Modifications of Original Code
 * as defined in and that are subject to the Apple Public Source License
 * Version 2.0 (the 'License'). You may not use this file except in
 * compliance with the License. Please obtain a copy of the License at
 * http://www.opensource.apple.com/apsl/ and read it before using this
 * file.
 * 
 * The Original Code and all software distributed under the License are
 * distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
 * EXPRESS OR IMPLIED, AND APPLE HEREBY DISCLAIMS ALL SUCH WARRANTIES,
 * INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR NON-INFRINGEMENT.
 * Please see the License for the specific language governing rights and
 * limitations under the License.
 * 
 * @APPLE_LICENSE_HEADER_END@
 */


#include <Security/SecRandom.h>
#include <CoreFoundation/CoreFoundation.h>
#include <stdlib.h>
#include <unistd.h>

#include "Security_regressions.h"

static int dummy;
static SecRandomRef kSecRandomNotDefault = (SecRandomRef)&dummy;

/* Test basic add delete update copy matching stuff. */
static void tests(void)
{
	UInt8 bytes[4096] = {};
	CFIndex size = 42;
	UInt8 *p = bytes + 23;
	ok_status(SecRandomCopyBytes(kSecRandomDefault, size, p), "generate some random bytes");
    ok_status(SecRandomCopyBytes(kSecRandomNotDefault, size, p), "ignore random implementation specifier");
}

int si_50_secrandom(int argc, char *const *argv)
{
	plan_tests(2);


	tests();

	return 0;
}
